/*
 *  soapUI, copyright (C) 2004-2007 eviware.com 
 *
 *  soapUI is free software; you can redistribute it and/or modify it under the 
 *  terms of version 2.1 of the GNU Lesser General Public License as published by 
 *  the Free Software Foundation.
 *
 *  soapUI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without 
 *  even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 *  See the GNU Lesser General Public License for more details at gnu.org.
 */

package com.eviware.soapui.impl.wsdl.panels.request.components.editor;

import javax.swing.JComponent;

import com.eviware.soapui.support.PropertyChangeNotifier;

/**
 * Views available for the XmlDocument of a XmlEditor
 * 
 * @author ole.matzura
 */

public interface XmlEditorView extends PropertyChangeNotifier, XmlLocationListener
{
	public final static String TITLE_PROPERTY = XmlEditorView.class.getName() + "@title";
	
	public XmlEditor getEditor();
	
	public String getTitle();
	
	public JComponent getComponent();
	
	public boolean deactivate();
	
	public boolean activate( XmlLocation location );
	
	public XmlLocation getLocation();
	
	public void setLocation( XmlLocation location );
	
	public void setXmlDocument(XmlDocument xmlDocument);
	
	public XmlDocument getXmlDocument();
	
	public boolean saveDocument( boolean validate );

	public void addLocationListener( XmlLocationListener listener );
	
	public void removeLocationListener( XmlLocationListener listener );
	
	public void release();

//	public boolean isInspectable();

	public void setEditable( boolean enabled );

	public String getViewId();

	public void requestFocus();
}
